/*-------------------------------------------------------------------------------------
 *
 * Simple Sample Application Framework
 *
 * 1991 Apple Computer
 *
 -------------------------------------------------------------------------------------*/
/*
 * main.c -- main entry point and initialization
 *
 * change history:
 *
 * SJF		11/6/91		1.0d1		initial coding
 *
 */

#include <Traps.h>

#include "const.h"
#include "mytypes.h"
#include "mymenus.h"
#include "globals.h"
#include "utils.h"
#include "trapavailable.h"
#include "events.h"
#include "aevt.h"
#include "patches.h"
#include "grafstuff.h"

#include "main.h"

/* main entry point */

void main(void)
{
	if (InitToolboxes()==noErr && InitApplication()==noErr)
		MainLoop();
	
	RemoveMonitorData();
	RemovePatches();
	ExitProgram();
	ExitToShell();
}


/* initializes the standard Mac toolbox */

OSErr InitToolboxes(void)
{
	MaxApplZone();
	MoreMasters();
	MoreMasters();
	MoreMasters();
	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(nil);
	InitCursor();
	FlushEvents(everyEvent,0L);
	
	if (SupportsAEVT()) {
		RegisterMyEvents();
	}
		
#ifdef __SYSEQU__
	BlockMove((long *)TimeLM,(long *)RndSeed,sizeof(long));
#else
	RndSeed = Time;
#endif

	return noErr;
}


/* initializes the application globals/menus/windows/etc... */

OSErr InitApplication(void)
{
	CursHandle cursH;
	
	// global variable initialization
	
	gHasWaitNextEvent = TrapAvailable(_WaitNextEvent);
		
	gDone = false;
	gInBackground = false;
	
	InstallPatches();
	SetupMonitorData();
	
	InitMyMenus();
	InitMyWindows();
	
	return noErr;
}


void InitMyMenus(void)
{
	Handle mbarHandle;
	MenuHandle appleMenu;
	
	mbarHandle = GetNewMBar(kMenuBarID);
	SetMenuBar(mbarHandle);
	
	appleMenu = GetMHandle(kAppleMenu);
	AddResMenu(appleMenu,'DRVR');			// build apple menu

	SetDefaultMenus();
	DrawMenuBar();
}


void InitMyWindows(void)
{
}
