#ifndef __GRAPHICSMODULE_TYPES__
#include "GraphicsModule_Types.h"
#endif

#define	kDimmerResType		'ADgm'
#define	kSoundChannelRes	'Chnl'
#define kMemoryResType		'sysz'
#define	kCallSupportedRes	'Cals'

#define	kNumControls		4

#define	kSliderResType		'sVal'
#define	kCheckBoxResType	'xVal'
#define	kTextResType		'tVal'
#define	kMenuResType		'mVal'
#define	kADExtensionsType	'ADex'

#define	kNotEnoughMemory	-100

#define	kNumMessages		6

#define	hasInit				0
#define	hasBlank			1
#define	hasDrawFrame		2
#define	hasClose			3
#define	hasModSelect		4
#define	hasHelp				5

typedef pascal OSErr (*ADDimmer)(Handle *storage,RgnHandle blankRgn,
								short message,GMParamBlockPtr params);
								
typedef struct {
	Handle			theDimmer;
	Handle			dimStorage;
	RgnHandle		dimRgn;
	GMParamBlockPtr dimVars;
	short			resFile;
	THz				dimZone;
	Boolean			callsSupported[kNumMessages];
} DimmerModule, *DimmerModulePtr;


typedef short WindowKind;

typedef struct TInfo TInfo,*TInfoPtr,**TInfoHndl;
typedef void *(*MsgProc)(WindowPtr window,TInfoPtr info,void *data);

struct TInfo {

	WindowPtr window;
	
	FSSpec	fileSpec;
		
	void	*data;
	
	MsgProc	m_idle;
	MsgProc	m_fixCursor;
	MsgProc	m_activate;
	MsgProc	m_deactivate;
	MsgProc	m_update;
	MsgProc	m_key;
	MsgProc	m_resize;
	MsgProc	m_click;
	MsgProc	m_destroy;
	MsgProc	m_undo;
	MsgProc	m_cut;
	MsgProc	m_copy;
	MsgProc	m_paste;
	MsgProc	m_clear;
	MsgProc	m_print;
	MsgProc	m_pageSetup;
	MsgProc	m_save;
	MsgProc	m_load;
	MsgProc	m_event;

	Boolean	saved;
	Boolean changed;

	void	*otherData[8];
	Boolean	otherFlags[8];
};
