(* ****************************************************************

		SendInCardIBeg.p
					Written in MPW Pascal by Darryl Lovato (dgl).
					
		Copyright  1993 Aladdin Systems, Inc.
		All Rights Reserved.
		
		In combination with the associated make file
		(SendInCardIBeg.make), this source text produces an IBeg
		installer extension, which can be called by a Product
		Installer at the start of the installation process.
		Specifications for IBeg, IMid, ICnd, and IEnd installer
		extensions are given in the documentation for StuffIt
		InstallerMaker.
		
		WARNING:  THE IBegAndSound RESOURCE FILE, INCLUDED IN THE
		INSTALLERMAKER PRODUCT SUITE, CONTAINS BOTH THE EXECUTABLE
		CODE RESOURCE AND ITS ASSOCIATED SOUND RESOURCE.  THE RESOURCE
		FILE PRODUCED BY SendInCardIBeg.make (SendInCardIBeg), CONTAINS
		THE CODE RESOURCE ONLY.  YOU MUST USE RESEDIT OR A SIMILAR
		UTILITY TO EXTRACT THE SOUND RESOURCE FROM IBegAndSound AND
		MERGE IT INTO THE SendInCardIBeg IBEG CODE RESOURCE FILE.  THE
		RESULTING, MERGED FILE CAN BE USED AS AN INCLUDED RESOURCE FILE
		BY THE INSTALLERMAKER PROGRAM.
		
		This subroutine performs the following functions:
           
		 Loads and plays the snd=128 resource in the Product
		  Installer's resource fork, using the SndPlay call.
		 Returns status code from SndPlay.
		
		CHANGE HISTORY:
		
		VER	DATE		ENGR	DESCRIPTION
		1	93.06.21	dgl		Initial version.
		2	93.06.22	jam		Added commentary and modified style to
								match other source files in the
								InstallerMaker suite.
		3	93.06.28	jam		Changed DoBeforeInstalling declaration
								to conform to new pw parameter spec.

****************************************************************** *)

(*$Z+*) (*	Allows linker to find DoBeforeInstalling without
			declaring it in the interface *)	 
UNIT IBeg;

INTERFACE

IMPLEMENTATION

   USES
     Types,
	 Sound,
	 Resources;

  FUNCTION DoBeforeInstalling(VAR pw: str255): INTEGER;
    VAR
	  theSound : Handle;
  BEGIN (* DoBeforeInstalling *)
	(* Get the sound!  We can assume the current resource file
	   is the Product Installer. *)
	theSound := GetResource('snd ',128);
	
	(* Now play it.  If SndPlay returns noErr, then installation
	   will continue, otherwise installation will stop. *)
	DoBeforeInstalling := SndPlay(nil,theSound,false);
	
	(* Clean up the world before departing. *)
	ReleaseResource(theSound);
  END (* DoBeforeInstalling *);
END (* IBeg *).