/*  CIncludesCode - an MPW tool - by John Jeppson

	This tool should normally be called by CIncludesTool MPW Script
	
	See Instructions file for usage.

*/


#include "CIncludesCode.h"

Handle			database = 0;
long			numFiles;
dataHeaderType	dataHeader;

short validateArguments( int argc, char *argv[] )
{ // terminates tool if bad parameters

	switch ( argc )
	{
		case 1:
		case 2:
			exit( 1 );
			break;
			
		case 3:
			if ( strcmp( argv[1], "-v" ) == 0 )
				return 2;
			if ( strcmp( argv[1], "-f" ) == 0 )
				return 3;
			if ( strcmp( argv[1], "-i" ) == 0 )
				return 4;
			if ( strcmp( argv[1], "-d" ) == 0 )   // Daniel Grassi
        		return 5;
			exit( 1 );
			break;
		
		default:
			if ( strcmp( argv[1], "-m" ) == 0 )
				return 1;
			exit( 1 );
			break;
	}
}


int main ( int argc, char *argv[], char *envp[] )
{
	#pragma unused (envp)
	char	s[64];
	long	filePosition;

	switch ( validateArguments( argc, argv ) )
	{
		case 1:		// -m
			return ( createDataBase( argc, argv ) );
			break;
		case 2:		// -v
			return ( validate( argv[2] ) );
			break;
		case 3:		// -f
			if ( !loadDatabase() )
				return( 3 );
			if ( locateIdentifier( s, &filePosition, argv[2] ) )
				printf( "#include <%s>\n", s );
			else
				return( 4 );
			break;
		case 4:		// -i
			if ( !loadDatabase() )
				return( 3 );
			return ( reformat( argv[2] ) );
			break;
		case 5:     // -d				// Daniel Grassi
	        if ( !loadDatabase() )
                return( 3 );
	        if ( locateIdentifier( s, &filePosition, argv[2] ) )
                printf( "\"%s\"  %d", s, filePosition );
	        else
                return( 4 );
	        break;
	}

	return 0;
}

