;; geometry.dyl

(define-class <point> (<object>)
	(x type: <number>
		init-value: 0
		init-keyword: x:)
	(y type: <number>
		init-value: 0
		init-keyword: x:)
	(z type: <number>
		init-value: 0
		init-keyword: z:)
)

(define-method binary+ ((n1 <number>) (p2 <point>))
	(make <point>
		x: (+ n1 (x p2))
		y: (+ n1 (y p2))
		z: (+ n1 (z p2))))

(define-method binary+ ((p1 <point>) (p2 <point>))
	(make <point>
		x: (+ (x p1) (x p2))
		y: (+ (y p1) (y p2))
		z: (+ (z p1) (z p2))))

(define-method binary- ((n1 <number>) (p2 <point>))
	(make <point>
		x: (- n1 (x p2))
		y: (- n1 (y p2))
		z: (- n1 (z p2))))

(define-method binary- ((p1 <point>) (p2 <point>))
	(make <point>
		x: (- (x p1) (x p2))
		y: (- (y p1) (y p2))
		z: (- (z p1) (z p2))))

(define-class <rect> (<object>)
	(top type: <integer>
		init-value: 0
		init-keyword: top:)
	(left type: <integer>
		init-value: 0
		init-keyword: left:)
	(bottom type: <integer>
		init-value: 100
		init-keyword: bottom:)
	(right type: <integer>
		init-value: 100
		init-keyword: right:)
	(color
		init-value: 'red
		init-keyword: color:)
)

(define-method offset-rect! ((r <rect>) (dx <integer>) (dy <integer>))
	(begin
		(set! (left r) (+ (left r) dx))
		(set! (top r) (+ (top r) dy))
		(set! (right r) (+ (right r) dx))
		(set! (bottom r) (+ (bottom r) dy))
		r))
