/*

   stream.h

   Copyright, 1993, Brent Benson.  All Rights Reserved.

   Permission to use, copy, and modify this software and its
   documentation is hereby granted only under the following terms and
   conditions.  Both the above copyright notice and this permission
   notice must appear in all copies of the software, derivative works
   or modified version, and both notices must appear in supporting
   documentation.  Users of this software agree to the terms and
   conditions set forth in this notice and agree to inform the author,
   Brent Benson, of any noteworthy uses of this software.

*/

#ifndef STREAM_H
#define STREAM_H

#include "object.h"

void init_stream_prims (void);
Object make_stream (enum streamtype type, FILE *fp);
Object open_input_file (Object filename);
Object open_output_file (Object filename);
Object close_stream (Object stream);

/* globals */
extern Object standard_input_stream;
extern Object standard_output_stream;
extern Object standard_error_stream;

#endif

