/*
 * File: Hex.r
 *
 * Rez definitions for Hex converter program
 *
 *	 28/1/88	Converted from TML Pascal/MDS RMaker etc to MPW 2.0.2
 *	23/10/88	Converted to MPW Tool
 *	15/12/88	Upgraded to MPW 3.0b1
 *	  6/5/90	Upgraded to MPW 3.1
 *	 26/5/90	Added VersionDialog entry and dialog so that version will
 *				be displayed in Commando dialog
 *	 30/9/92	Upgraded to MPW 3.3
 *	 			Tidied up for release
 *
 * Copyright Paul Russell, ARC Electronics 1987-1992.
 *
 */

#include "types.r"
#include "cmdo.r"

type 'MPST' as 'STR ';

resource 'MPST' (0)
{
	"Version 1.021"				/* MPW version resource (used by SetVersion Tool) */
};

resource 'cmdo' (256) {
	{
		240,
		"Hex reads a resource and converts it to ASCII hex",
		{
			NotDependent {}, Files {
				InputFile,
				RequiredFile {
					{20, 20, 40, 150},
					"Resource File",
					"",
					"Select the resource file",
				},
				Additional {
					"",
					FilterTypes,
					"Only applications",
					"All files",
					{
						appl
					}
				}
			},
			NotDependent {}, CheckOption {
				NotSet,
				{20, 200, 36, 280},
				"Progress",
				"-p",
				"Write progress information to diagnostic output"
			},
			NotDependent {}, RegularEntry {
				"Address",
				{50, 200, 65, 260},
				{50, 260, 65, 320},
				"$0000",
				ignoreCase,
				"-a",
				"Set the start address of the ASCII HEX output file"
			},
			NotDependent {}, RadioButtons {
				{
					{46, 20, 61, 120},
					"Raw",
					"-h raw",
					notset,
					"Produce raw ASCII HEX output",
					
					{62, 20, 77, 120},
					"Intel",
					"-h intel",
					set,
					"Produce Intel format HEX output",
					
					{78, 20, 93, 120},
					"Motorola S1",
					"-h s1",
					notset,
					"Produce Motorola S1 format HEX output",
					
					{94, 20, 109, 120},
					"Motorola S2",
					"-h s2",
					notset,
					"Produce Motorola S2 format HEX output",
					
					{110, 20, 125, 120},
					"Motorola S3",
					"-h s3",
					notset,
					"Produce Motorola S3 format HEX output",
				}
			},
			NotDependent {}, RadioButtons {
				{
					{78, 130, 93, 190},
					"All",
					"-m all",
					set,
					"Convert all bytes",
					
					{94, 130, 109, 190},
					"Even",
					"-m even",
					notset,
					"Convert only even bytes",
					
					{110, 130, 125, 190},
					"Odd",
					"-m odd",
					notset,
					"Convert only odd bytes",
				}
			},
			NotDependent {}, RegularEntry {
				"Type",
				{70, 200, 85, 260},
				{70, 260, 85, 320},
				"CODE",
				keepCase,
				"-r",
				"Set the type of the resource to convert"
			},
			NotDependent {}, RegularEntry {
				"ID",
				{90, 200, 105, 260},
				{90, 260, 105, 320},
				"1",
				ignoreCase,
				"-i",
				"Set the ID of the resource to convert"
			},
			NotDependent {}, RegularEntry {
				"Skip",
				{110, 200, 125, 260},
				{110, 260, 125, 320},
				"4",
				ignoreCase,
				"-s",
				"Set the number of bytes to skip at the start of the resource"
			},
			NotDependent {}, Redirection {
				StandardOutput,
				{40, 340}
			},
			NotDependent {}, Redirection {
				DiagnosticOutput,
				{80, 340}
			},
			NotDependent {}, TextBox {
				gray,
				{30, 335, 121, 460},
				"Redirection"
			},
			Or {{1}}, DoItButton {
			},
			NotDependent {}, VersionDialog {
				VersionResource {
					'MPST', 0
				},
				"by Paul Russell, ARC Electronics, 1987-1992",
				256
			}
		}
	}
};

resource 'DLOG' (256) {
	{160, 114, 248, 502},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	256,
	""
};

resource 'DITL' (256, purgeable) {
	{
		{16, 16, 48, 48}, Icon { enabled, 256 },
		{16, 64, 80, 364}, StaticText { enabled, "Hex\n\nby Paul Russell, ARC Electronics, 1987-1992" }
	}
};

resource 'ICON' (256) {
	$"0000 0000 2727 1CA8 28A8 A2A8 28A8 A2A8"
	$"28A8 A2A8 28A8 A2A8 2727 1CA8 0000 0000"
	$"0000 0000 003F F800 0020 0800 0020 0800"
	$"01E0 0F00 0080 0200 0040 0400 0020 0800"
	$"0010 1000 0008 2000 0004 4000 0002 8000"
	$"0001 0000 0000 0000 0000 0000 0000 0000"
	$"001C F800 0022 0800 0022 0800 003E 1000"
	$"0022 2000 0022 2000 0000 0000 0000 0000"
};
