/**********************************************************************\

File:		Four box in fade.c

Purpose:	Graphic effect to fade main window to solid pattern.
			See comments below for more description.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "timing.h"

#define CorrectTime 1
#define theWindowWidth (boundsRect.right-boundsRect.left)
#define theWindowHeight (boundsRect.bottom-boundsRect.top)

pascal short main(Rect boundsRect, Pattern *thePattern);

pascal short main(Rect boundsRect, Pattern *thePattern)
{
	short			hOffset, vOffset;
	short			cx, cy;
	Rect			vRect1, vRect2, vRect3, vRect4;
	Rect			hRect1, hRect2, hRect3, hRect4;
	
	cx=boundsRect.left+(theWindowWidth/2);
	cy=boundsRect.top+(theWindowHeight/2);
	
	hOffset=vOffset=1;
	
	vRect1.left=hRect1.left=hRect2.left=hRect3.left=hRect4.left=boundsRect.left;
	vRect1.top=vRect2.top=vRect3.top=vRect4.top=hRect1.top=boundsRect.top;
	vRect1.right=boundsRect.left+vOffset;
	vRect1.bottom=vRect2.bottom=vRect3.bottom=vRect4.bottom=hRect4.bottom=boundsRect.bottom;
	vRect2.left=cx-vOffset;
	vRect2.right=vRect3.left=cx;
	vRect3.right=cx+vOffset;
	vRect4.left=boundsRect.right-vOffset;
	vRect4.right=hRect1.right=hRect2.right=hRect3.right=hRect4.right=boundsRect.right;
	hRect1.bottom=boundsRect.top+hOffset;
	hRect2.top=cy-hOffset;
	hRect2.bottom=hRect3.top=cy;
	hRect3.bottom=cy+hOffset;
	hRect4.top=boundsRect.bottom-hOffset;
	
	while ((vRect1.right<=vRect2.left) && (hRect1.bottom<=hRect2.top))
	{
		StartTiming();
		FillRect(&vRect1, *thePattern);
		FillRect(&vRect2, *thePattern);
		FillRect(&vRect3, *thePattern);
		FillRect(&vRect4, *thePattern);
		FillRect(&hRect1, *thePattern);
		FillRect(&hRect2, *thePattern);
		FillRect(&hRect3, *thePattern);
		FillRect(&hRect4, *thePattern);
		vRect1.left+=vOffset;
		vRect1.right+=vOffset;
		vRect2.left-=vOffset;
		vRect2.right-=vOffset;
		vRect3.left+=vOffset;
		vRect3.right+=vOffset;
		vRect4.left-=vOffset;
		vRect4.right-=vOffset;
		hRect1.top+=hOffset;
		hRect1.bottom+=hOffset;
		hRect2.top-=hOffset;
		hRect2.bottom-=hOffset;
		hRect3.top+=hOffset;
		hRect3.bottom+=hOffset;
		hRect4.top-=hOffset;
		hRect4.bottom-=hOffset;
		TimeCorrection(CorrectTime);
	}
	
	FillRect(&boundsRect, *thePattern);
	
	return 0;
}
