/**********************************************************************\

File:		Horizontal bars fade.c

Purpose:	Graphic effect to fade main window to solid pattern.
			See comments below for more description.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "timing.h"

#define CorrectTime 1
#define theWindowWidth (boundsRect.right-boundsRect.left)
#define theWindowHeight (boundsRect.bottom-boundsRect.top)

pascal short main(Rect boundsRect, Pattern *thePattern);

pascal short main(Rect boundsRect, Pattern *thePattern)
{
	RgnHandle		leftRgn, rightRgn;
	short			offset;
	short			iter;
	short			barHeight;
	Point			zeroPoint;
	
	offset=2;
	barHeight=theWindowHeight/40;
	zeroPoint.h=0;
	zeroPoint.v=barHeight;
	
	leftRgn=NewRgn();
	OpenRgn();
		MoveTo(0, 0);
		iter=0;
		while (iter<theWindowHeight)
		{
			Line(offset, 0);
			Line(0, barHeight);
			Line(-offset, 0);
			Line(0, -barHeight);
			Move(0, barHeight*2);
			iter+=barHeight*2;
		}
	CloseRgn(leftRgn);
	OffsetRgn(leftRgn, boundsRect.left, boundsRect.top);
	
	rightRgn=NewRgn();
	OpenRgn();
		MoveTo(theWindowWidth, barHeight);
		iter=0;
		while (iter<theWindowHeight)
		{
			Line(-offset, 0);
			Line(0, barHeight);
			Line(offset, 0);
			Line(0, -barHeight);
			Move(0, barHeight*2);
			iter+=barHeight*2;
		}
	CloseRgn(rightRgn);
	OffsetRgn(rightRgn, boundsRect.left, boundsRect.top);
	
	while (!PtInRgn(zeroPoint, rightRgn))
	{
		StartTiming();
		FillRgn(leftRgn, *thePattern);
		FillRgn(rightRgn, *thePattern);
		OffsetRgn(leftRgn, offset, 0);
		OffsetRgn(rightRgn, -offset, 0);
		TimeCorrection(CorrectTime);
	}
	
	FillRect(&boundsRect, *thePattern);
	
	DisposeRgn(leftRgn);
	DisposeRgn(rightRgn);
	
	return 0;
}
