/**********************************************************************\

File:		Jaws fade.c

Purpose:	Graphic effect to fade main window to solid pattern.
			See comments below for more description.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "timing.h"

#define CorrectTime 1
#define theWindowWidth (boundsRect.right-boundsRect.left)
#define theWindowHeight (boundsRect.bottom-boundsRect.top)

pascal short main(Rect boundsRect, Pattern *thePattern);

pascal short main(Rect boundsRect, Pattern *thePattern)
{
	RgnHandle		topRgn, bottomRgn, unionRgn;
	short			offset;
	short			jawsHeight;
	
	jawsHeight=theWindowHeight/4;
	offset=3;
	
	topRgn=NewRgn();
	OpenRgn();
		MoveTo(0, -offset);
		LineTo(0, jawsHeight);
		LineTo(theWindowWidth/8, 0);
		LineTo(theWindowWidth/4, jawsHeight);
		LineTo(theWindowWidth*3/8, 0);
		LineTo(theWindowWidth/2, jawsHeight);
		LineTo(theWindowWidth*5/8, 0);
		LineTo(theWindowWidth*3/4, jawsHeight);
		LineTo(theWindowWidth*7/8, 0);
		LineTo(theWindowWidth, jawsHeight);
		LineTo(theWindowWidth, 0);
		LineTo(theWindowWidth, -offset);
		LineTo(0, -offset);
	CloseRgn(topRgn);
	OffsetRgn(topRgn, boundsRect.left, boundsRect.top-jawsHeight);
	
	bottomRgn=NewRgn();
	OpenRgn();
		MoveTo(0, theWindowHeight+offset);
		LineTo(0, theWindowHeight);
		LineTo(theWindowWidth/8, theWindowHeight-jawsHeight);
		LineTo(theWindowWidth/4, theWindowHeight);
		LineTo(theWindowWidth*3/8, theWindowHeight-jawsHeight);
		LineTo(theWindowWidth/2, theWindowHeight);
		LineTo(theWindowWidth*5/8, theWindowHeight-jawsHeight);
		LineTo(theWindowWidth*3/4, theWindowHeight);
		LineTo(theWindowWidth*7/8, theWindowHeight-jawsHeight);
		LineTo(theWindowWidth, theWindowHeight);
		LineTo(theWindowWidth, theWindowHeight+offset);
		LineTo(0, theWindowHeight+offset);
	CloseRgn(bottomRgn);
	OffsetRgn(bottomRgn, boundsRect.left, boundsRect.top+jawsHeight);
	
	unionRgn=NewRgn();
	do
	{
		StartTiming();
		SetEmptyRgn(unionRgn);
		SectRgn(topRgn, bottomRgn, unionRgn);
		FillRgn(topRgn, *thePattern);
		FillRgn(bottomRgn, *thePattern);
		OffsetRgn(topRgn, 0, offset);
		OffsetRgn(bottomRgn, 0, -offset);
		TimeCorrection(CorrectTime);
	}
	while (EmptyRgn(unionRgn));
	
	DisposeRgn(unionRgn);
	DisposeRgn(topRgn);
	DisposeRgn(bottomRgn);
	
	return 0;
}
