/**********************************************************************\

File:		init.c

Purpose:	This module handles INIT initialization and installation.
			
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "init.h"
#include "environment.h"
#include "prefs.h"
#include "really notify.h"
#include "sfx meat.h"
#include "sfx install.h"
#include "sfx gestalt.h"
#include "program globals.h"

char			gOnShutdown, gOnRestart, gChooseRandom, gFadeEarly;
short			gModuleIndex;

void __GetA4(void)
{
	asm
	{
		bsr.s	@1
		dc.l	0			;  store A4 here
@1		move.l	(sp)+,a1
	}
}

/* this be the init startup install routine thing */
void main(void)
{
	short			resultCode;
	
	RememberA0();
	SetUpA4();
	
	if ((resultCode=InitTheEnvironment())!=0)
	{
		StartupError(resultCode);
	}
	else
	{
		if ((resultCode=DoSetup())==0)
		{
			StartupGood();
		}
		else
		{
			StartupError(resultCode);
		}
	}
	
	RestoreA4();
}

short DoSetup(void)
{
	short			resultCode;
	short			vRefNum;
	long			dirID;
	Str255			theName;
	
	resultCode=PreferencesInit();
	if ((resultCode!=prefs_allsWell) && (resultCode!=prefs_virginErr))
		return kPrefsError;
	
	if ((resultCode=GetAModule(&gModuleIndex, theName, &vRefNum, &dirID))!=0)
		return resultCode;
	
	if (!sfxGestaltFunctionInstalledQQ())
	{
		if ((resultCode=MakeNewGestaltSelectors())!=0)
			return resultCode;
		if ((resultCode=InstallTheShutdownProc(theName, vRefNum, dirID, gOnShutdown,
				gOnRestart, gFadeEarly))!=0)
			return resultCode;
		
		SaveThePrefs();
	}
	
	return 0;
}
