//#define DEBUG 1
// Modeless Dialog procedures for 'puriTEXT'
// Copyright (C) 1994 by Mizutori Tetsuya, 94/3/9, 94/3/21

#include "Defines.h"

// Prototypes (modelessDialog.c)
/***** Modeless dialog *****/
Boolean ModelessDialog( DialogPtr dialog, EventRecord *event, short *item );
Boolean IsDialogEdit( DialogPtr dialog, EventRecord *event );
pascal Boolean MyDialogFilter( DialogPtr dialog, EventRecord *event, short *item );

/***** Do Dialog Event *****/
Boolean ModelessDialog( DialogPtr dialog, EventRecord *event, short *item )
{
	DialogPtr	whichDialog;

	if ( IsDialogEvent( event ) )
		if ( ! IsDialogEdit( dialog, event ) )
			if ( DialogSelect( event, &whichDialog, item ) ) {
				MyDialogFilter( dialog, event, item );
				return( true ); }

	if ( MyDialogFilter( dialog, event, item ) )  return( true );

	return( false );
}

Boolean IsDialogEdit( DialogPtr dialog, EventRecord *event )
{
	char		theKey;

	if ( event->what != keyDown ) return( false );

	if ( ( event->modifiers & cmdKey ) == 0 ) return( false );

	theKey =  event->message & charCodeMask;

	switch ( theKey ) {
		case 'X':
		case 'x':	// DlgCut( dialog );
					return( true );
		case 'C':
		case 'c':	// DlgCopy( dialog );
					return( true );
		case 'V':
		case 'v':	// DlgPaste( dialog );
					return( true );
		case 'B':
		case 'b':	// DlgDelete( dialog );
					return( true );
		case 'A':
		case 'a':
//					TESetSelect( 0, MAXINT, ((DialogPeek)dialog)->textH );
					return( true );
		default:
					break;
	}

	return( false );
}

pascal Boolean MyDialogFilter( DialogPtr dialog, EventRecord *event, short *item )
{
	char		theKey;

	if ( event->what != keyDown ) return( false );

	theKey =  event->message & charCodeMask;

	switch ( theKey ) {
		case 0x03:					// for Enter key
		case '\r':					// for RET key
					*item = ok;
					return( true );
		case '.':					// for Command-. key
					if ( ( event->modifiers & cmdKey ) == 0 ) break;
		case 0x1B:					// for ESC key
					*item = cancel;
					return( true );
		default:
					break;
	}

	return( false );
}

/***** end of program *****/

//////////////////
// sample usage //
//////////////////

#ifdef SAMPLE_MODELESSDIALOG

Boolean	gDone;

void EventLoop( void )
{
	Boolean			gotEvent;
	WindowPtr		window;
	DialogPtr		whichDialog;
	EventRecord		event;
	short			itemHit;

	gDone = false;

	while ( gDone == false ) {
		gotEvent = WaitNextEvent(everyEvent,&event,kSleep,nil);
		window = FrontWindow();
		switch ( WindowType( window ) ) {
		case kMyRefCon:
			if ( gotEvent ) {
				if ( ModelessDialog( (DialogPtr)window, &event, &itemHit ) )
					if ( HandleHitItem( (DialogPtr)window, itemHit ) ) break;
				DoEvent( &event );
			} else {
				DialogSelect( &event, &whichDialog, &itemHit );
			}
			break;
		default:
			if ( gotEvent ) DoEvent( &event );
			break;
		}

		AdjustCursor( window, event.where );
		SystemTask();
	}
}

Boolean HandleHitItem( DialogPtr dialog, short item )
{	
	Boolean			result;

	result = true;
	switch ( item ) {
		case ok:
		case cancel:
			gDone = true;
			break;
		case iTitle:
		case iIcon:
			DoAbout();
			break;
		case iUserItem:
//			DoUserItem( (WindowPtr) dialog );
			result = false;
			break;
		default:
			result = false;
	}

	return( result );
}

#endif SAMPLE_MODELESSDIALOG

// end of samples
