#include "screen.h"

extern short font;
extern short style;
extern unsigned long IDLETICKS;
extern ConstStr255Param title;

void ReadPrefs(void) {
	OSErr			myErr;
	short			volRefNum;
	long			dirID;
	StringHandle	h;
	FSSpec			myFSS;
	short			refNum;
	long			length;
	
	short			version;
	Str255			fontname;
	
// Find the Preferences folder; create it if need be

	myErr = FindFolder(kOnSystemDisk, kPreferencesFolderType, kCreateFolder,
						&volRefNum, &dirID);

// Make a filespec for Clock Screen Saver Preferences

	h = GetString(129);
	
	HNoPurge((Handle)h);
	HLock((Handle)h);
	if (myErr == noErr)
		myErr = FSMakeFSSpec(volRefNum, dirID, *h, &myFSS);
	HUnlock((Handle)h);
	HPurge((Handle)h);
	
// Open the preferences file

	if (myErr == noErr)	myErr == FSpOpenDF(&myFSS, fsCurPerm, &refNum);

// Rewind to the beginning

	if (myErr == noErr)
		myErr = SetFPos((short)refNum, fsFromStart, 0L);


#define munch(yummy) \
	length = sizeof(yummy); \
	if (myErr == noErr) myErr = FSRead(refNum, &length, &yummy);

// Read the version, idle ticks, style, and font name

	munch(version);
	munch(IDLETICKS);
	munch(style);
	munch(fontname);
	if (myErr == noErr) myErr = FSClose(refNum);

	GetFNum((ConstStr255Param)fontname,&font);
	if (IDLETICKS<1*60*60 || IDLETICKS>29*60*60) IDLETICKS=(5*60*60);

	if (myErr == noErr) return;
	
	/* set up defaults in case there was a problem */
	font = 1; // Geneva
	style = bold;
	IDLETICKS = (60*60*5);
	return;
}

void WritePrefs(void) {
	OSErr		myErr;
	short		volRefNum;
	long		dirID;
	StringHandle h;
	FSSpec		myFSS;
	short		refNum;
	
	long		length;
	short		version;
	Str255		fontname;
	
// Find the Preferences folder; create it if need be

	myErr = FindFolder(kOnSystemDisk, kPreferencesFolderType, kCreateFolder,
						&volRefNum, &dirID);
	if (myErr != noErr) return;
	
// Make a filespec for Clock Screen Saver Preferences

	h=GetString(129);
	HNoPurge((Handle)h);
	HLock((Handle)h);
	myErr = FSMakeFSSpec(volRefNum, dirID, *h, &myFSS);
	HUnlock((Handle)h);
	HPurge((Handle)h);
	if (myErr != noErr && myErr != fnfErr) return;

	// create the new file as generic data
	
	myErr = FSpCreate(&myFSS,'????','????',smSystemScript);
	if (myErr != noErr) return;

// Open the preferences file

	myErr == FSpOpenDF(&myFSS, fsRdWrPerm, &refNum);
	if (myErr != noErr) return;
	
// Rewind to the beginning; write the version, font name, style, and delay; and close
	
	SetFPos(refNum, fsFromStart, 0);

	version = 0x0101; // 1.1
	length = sizeof(version); FSWrite(refNum, &length, &version);

	length = sizeof(IDLETICKS); FSWrite(refNum, &length, &IDLETICKS);

	length = sizeof(style); FSWrite(refNum, &length, &style);

	GetFontName(font,fontname);
	length = sizeof(fontname); FSWrite(refNum, &length, fontname);

	GetFPos(refNum, &length);
	SetEOF(refNum, length);

	GetVRefNum(refNum, &volRefNum);
	FlushVol((StringPtr)nil, volRefNum);
	FSClose(refNum);
	return;
}
