# FILE: setVar.tcl
#
# LAST UPDATE: 01/07/93 4:40:25 AM
#
# This file contains the following TCL procedure(s):
#
#	setVar -- sets a global variable
#	getVar -- returns the value of a global variable
#
#	These routines simulate the absence of these correspoding
#	commands from earlier versions of Alpha.  Useful working with
#	old scripts.

# COPYRIGHT:
#
#	Copyright  1993 by David C. Black
#	All rights reserved.
#
#	Redistribution and use in source and binary forms are permitted
#	provided that the above copyright notice and this paragraph are
#	duplicated in all such forms and that any documentation,
#	advertising materials, and other materials related to such
#	distribution and use acknowledge that the software was developed
#	by David C. Black.
#
#	THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
#	IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
#	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
################################################################################

# AUTHOR
#	
#	David C. Black
#	Internet: black@mpd.tandem.com
#	GEnie:    D.C.BLACK
#	USnail:   6217 John Chisum Lane, Austin, Tx 78749-1838
#
################################################################################

proc setVar {name value} {
	upvar #0 $name theVar
	set theVar $value
}

proc getVar {name} {
	upvar #0 $name theVar
	return $theVar
}
