#ifndef __COMMON__
#define __COMMON__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __APPLETALK__
#include <AppleTalk.h>
#endif

#define kSuccessIcon		-4064
#define kFailureIcon		-4033
#define kPrefsName			0
#define kDefaultSelector	'MOCK'

#if __powerpc
extern	long	gControlTrap;
extern	OSType	gGestaltSelector;

/*
	powerpc invisible defines.
*/

#define setGestalt(x) (gGestaltSelector = x)
#define setTrap(x) (gControlTrap = x)
#define NewGestaltValue _NewGest
#define _NewGest(x,y) 0
#define getGestalt (gGestaltSelector)

#else

void setGestalt(OSType theType);
void setTrap(long theTrap);
OSType getGestalt(void);

#endif

OSErr HandleTrap(short trapword, MPPPBPtr pb);
void MyPatch(void);

#define lookupEnabled(x) (x & 1)
#define lookupAsync(x) (x & 2)
//#define lookupRestore(x) (x & 4)
#define registerEnabled(x) (x & 8)
#define registerAsync(x) (x & 16)
//#define registerRestore(x) (x & 32)
#define removeEnabled(x) (x & 64)
#define removeAsync(x) (x & 128)
//#define removeRestore(x) (x & 256)

enum
{
	kLookupEnabled = 1,
	kLookupAsync = 2,
//	kLookupRestore = 4,
	kRegisterEnabled = 8,
	kRegisterAsync = 16,
//	kRegisterRestore = 32,
	kRemoveEnabled = 64,
	kRemoveAsync = 128,
//	kRemoveRestore = 256
};

typedef struct NameLink
{
	Str32				originalName;
	Str32				newString;
	struct	NameLink	*next, *previous;
} NameLink, *NameLinkPtr;

typedef struct OriginalLink
{
	Str32		originalName;
	long		objectPrefs;
	struct OriginalLink *next;
} OriginalLink, *OriginalLinkPtr;

typedef struct
{
	NameLinkPtr		registeredNames;
	OriginalLinkPtr	trappedNames;
} MyGestaltRecord, *MyGestaltPtr;


OSType Initialize(long *theResult);
void INITInstall(void);

#endif